Index: gcc/testsuite/gfortran.dg/init_flag_12.f90
===================================================================
--- gcc/testsuite/gfortran.dg/init_flag_12.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/init_flag_12.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,13 @@
+! { dg-do compile }
+! { dg-options "-fno-automatic -finit-local-zero" }
+!
+! PR 55907: [4.7/4.8/4.9 Regression] ICE with -fno-automatic -finit-local-zero
+!
+! Contributed by J.R. Garcia <garcia.espinosa.jr@gmail.com>
+
+subroutine cchaine (i)
+  implicit none
+  integer :: i
+  character(len=i) :: chaine
+  write(*,*) chaine
+end subroutine 
Index: gcc/testsuite/gfortran.dg/derived_external_function_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/derived_external_function_1.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/derived_external_function_1.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,27 @@
+! { dg-do run }
+!
+! PR fortran/58771
+!
+! Contributed by Vittorio Secca  <zeccav@gmail.com>
+!
+! ICEd on the write statement with f() because the derived type backend
+! declaration not built.
+!
+module m
+  type t
+    integer(4) g
+  end type
+end
+
+type(t) function f() result(ff)
+  use m
+  ff%g = 42
+end
+
+  use m
+  character (20) :: line1, line2
+  type(t)  f
+  write (line1, *) f()
+  write (line2, *) 42_4
+  if (line1 .ne. line2) call abort
+end
Index: gcc/testsuite/gfortran.dg/null_6.f90
===================================================================
--- gcc/testsuite/gfortran.dg/null_6.f90	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gfortran.dg/null_6.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -30,5 +30,5 @@
 
 subroutine test_PR34547_3 ()
   integer, allocatable :: i(:)
-  print *, NULL(i)
+  print *, NULL(i)    ! { dg-error "Invalid context for NULL" }
 end subroutine test_PR34547_3
Index: gcc/testsuite/gfortran.dg/constructor_9.f90
===================================================================
--- gcc/testsuite/gfortran.dg/constructor_9.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/constructor_9.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,22 @@
+! { dg-do compile }
+! { dg-options "-Wall" }
+!
+! PR 58471: [4.8/4.9 Regression] ICE on invalid with missing type constructor and -Wall
+!
+! Contributed by Andrew Benson <abensonca@gmail.com>
+
+module cf
+  implicit none
+  type :: cfmde
+  end type
+  interface cfmde
+     module procedure mdedc   ! { dg-error "is neither function nor subroutine" }
+  end interface
+contains
+  subroutine cfi()
+    type(cfmde), pointer :: cfd
+    cfd=cfmde()                  ! { dg-error "Can't convert" }
+  end subroutine
+end module
+
+! { dg-final { cleanup-modules "cf" } }
Index: gcc/testsuite/gfortran.dg/round_3.f08
===================================================================
--- gcc/testsuite/gfortran.dg/round_3.f08	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gfortran.dg/round_3.f08	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -16,19 +16,44 @@
     call checkfmt("(RU,1P,G6.0E2)", 2.0,  "2.E+00")
     call checkfmt("(RU,1P,G10.4E2)", 2.3456e5,  "2.3456E+05")
 
-    call checkfmt("(RU,F2.0)",     0.09,  "1.")     ! 0.
+    call checkfmt("(RC,G10.2)", 99.5,   "  0.10E+03") ! pr59774
+    call checkfmt("(RC,G10.2)", 995.,   "  0.10E+04") ! pr59774
+    call checkfmt("(RC,G10.3)", 999.5,  " 0.100E+04") ! pr59774
+    call checkfmt("(RC,G10.3)", 9995.,  " 0.100E+05") ! pr59774
+    call checkfmt("(RU,G10.2)", .099,   "  0.10    ") ! pr59774
+    call checkfmt("(RC,G10.1)", .095,   "   0.1    ") ! pr59774
+    call checkfmt("(RU,G10.3)", .0999,  " 0.100    ") ! pr59774
+    call checkfmt("(RC,G10.2)", .0995,  "  0.10    ") ! pr59774
+
+    call checkfmt("(RU,G9.3)",  891.1,  " 892.")      ! pr59836
+    call checkfmt("(RD,G9.3)", -891.1,  "-892.")      ! pr59836
+    
+    call checkfmt("(RU,F6.4)",     0.00006,  "0.0001")! 0.
+    call checkfmt("(RU,F5.3)",     0.0007,  "0.001")  ! 0.
+    call checkfmt("(RU,F4.2)",     0.008,  "0.01")    ! 0.
+    call checkfmt("(RU,F3.1)",     0.09,  "0.1")      ! 0.
+
+    call checkfmt("(RU,F2.0)",     0.09,  "1.")       ! 0.
     call checkfmt("(RD,F3.0)",     -0.09,  "-1.")     ! -0.
-    call checkfmt("(RU,F2.0)",      2.0,  "2.")     ! 3.
-    call checkfmt("(RD,F3.0)",     -2.0,  "-2.")     ! -3.
-    call checkfmt("(RU,F6.4)",      2.0,  "2.0000")     ! 2.0001
-    call checkfmt("(RD,F7.4)",     -2.0,  "-2.0000")     ! -2.0001
-    call checkfmt("(RU,1P,E6.0E2)", 2.0,  "2.E+00") ! 3.E+00
+    call checkfmt("(RU,F2.0)",     0.9,  "1.")        ! pr59836
+    call checkfmt("(RC,F2.0)",     0.4,  "0.")        ! pr59836
+    call checkfmt("(RC,F2.0)",     0.5,  "1.")        ! pr59836
+    call checkfmt("(RC,F2.0)",     0.6,  "1.")        ! pr59836
+    call checkfmt("(RD,F3.0)",     -0.9,  "-1.")      ! pr59836
+    call checkfmt("(RC,F3.0)",     -0.4,  "-0.")      ! pr59836
+    call checkfmt("(RC,F3.0)",     -0.5,  "-1.")      ! pr59836
+    call checkfmt("(RC,F3.0)",     -0.6,  "-1.")      ! pr59836
+    call checkfmt("(RU,F2.0)",      2.0,  "2.")       ! 3.
+    call checkfmt("(RD,F3.0)",     -2.0,  "-2.")      ! -3.
+    call checkfmt("(RU,F6.4)",      2.0,  "2.0000")   ! 2.0001
+    call checkfmt("(RD,F7.4)",     -2.0,  "-2.0000")  ! -2.0001
+    call checkfmt("(RU,1P,E6.0E2)", 2.0,  "2.E+00")   ! 3.E+00
     call checkfmt("(RD,1P,E7.0E2)", -2.0,  "-2.E+00") ! -3.E+00
-    call checkfmt("(RU,1P,E7.1E2)", 2.5,  "2.5E+00") ! 2.6E+00
+    call checkfmt("(RU,1P,E7.1E2)", 2.5,  "2.5E+00")  ! 2.6E+00
     call checkfmt("(RD,1P,E8.1E2)", -2.5,  "-2.5E+00") ! -2.6E+00
     call checkfmt("(RU,1P,E10.4E2)", 2.5,  "2.5000E+00") ! 2.5001E+00
     call checkfmt("(RD,1P,E11.4E2)", -2.5,  "-2.5000E+00") ! -2.5001E+00
-    call checkfmt("(RU,1P,G6.0E2)", 2.0,  "2.E+00") ! 3.E+00
+    call checkfmt("(RU,1P,G6.0E2)", 2.0,  "2.E+00")   ! 3.E+00
     call checkfmt("(RD,1P,G7.0E2)", -2.0,  "-2.E+00") ! -3.E+00
     call checkfmt("(RU,1P,G10.4E2)", 2.3456e5,  "2.3456E+05") ! 2.3457E+05
     call checkfmt("(RD,1P,G11.4E2)", -2.3456e5,  "-2.3456E+05") ! -2.3457E+05
Index: gcc/testsuite/gfortran.dg/default_initialization_7.f90
===================================================================
--- gcc/testsuite/gfortran.dg/default_initialization_7.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/default_initialization_7.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,22 @@
+! { dg-do compile }
+!
+! PR fortran/57033
+! ICE on a structure constructor of an extended derived type whose parent
+! type last component has a default initializer
+!
+! Contributed by Tilo Schwarz <tilo@tilo-schwarz.de>
+
+program ice
+
+type m
+    integer i
+    logical :: f = .false.
+end type m
+
+type, extends(m) :: me
+end type me
+
+type(me) meo
+
+meo = me(1)              ! ICE
+end program ice
Index: gcc/testsuite/gfortran.dg/proc_ptr_46.f90
===================================================================
--- gcc/testsuite/gfortran.dg/proc_ptr_46.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/proc_ptr_46.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,14 @@
+! { dg-do compile }
+!
+! PR fortran/49397
+!
+! Invalid per IR F08/0060 and F2008Corr2, C729
+!
+
+!  Print *,f() ! << Valid when uncommented
+Contains
+  Subroutine s
+    Procedure(Real),Pointer :: p
+    p => f  ! { dg-error "Procedure pointer target 'f' at .1. must be either an intrinsic, host or use associated, referenced or have the EXTERNAL attribute" }
+  End Subroutine
+End
Index: gcc/testsuite/gfortran.dg/generic_28.f90
===================================================================
--- gcc/testsuite/gfortran.dg/generic_28.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/generic_28.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,18 @@
+! { dg-do compile }
+!
+! PR 58998: [4.8/4.9 Regression] Generic interface problem with gfortran
+!
+! Contributed by Paul van Delst
+
+  interface iargc
+    procedure iargc_8
+  end interface
+  
+contains
+
+  integer(8) function iargc_8()
+    integer(4) iargc
+    iargc_8 = iargc()
+  end function
+  
+end
Index: gcc/testsuite/gfortran.dg/unresolved_fixup_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/unresolved_fixup_1.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/unresolved_fixup_1.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,44 @@
+! { dg-do compile }
+!
+! PR fortran/58007
+! Unresolved fixup while loading a module.
+!
+! This tests that the specification expression A%MAX_DEGREE in module BSR is
+! correctly loaded and resolved in program MAIN.
+!
+! Original testcase from Daniel Shapiro <shapero@uw.edu>
+! Reduced by Tobias Burnus <burnus@net-b.de> and Janus Weil <janus@gcc.gnu.org>
+
+module matrix
+  type :: sparse_matrix
+    integer :: max_degree
+  end type
+contains
+  subroutine init_interface (A)
+    class(sparse_matrix), intent(in) :: A
+  end subroutine
+  real function get_value_interface()
+  end function
+end module
+
+module ellpack
+  use matrix
+end module
+
+module bsr
+  use matrix
+  type, extends(sparse_matrix) :: bsr_matrix
+  contains
+    procedure :: get_neighbors
+  end type
+contains
+  function get_neighbors (A)
+    class(bsr_matrix), intent(in) :: A
+    integer :: get_neighbors(A%max_degree)
+  end function
+end module
+
+program main
+  use ellpack
+  use bsr
+end
Index: gcc/testsuite/gfortran.dg/null_5.f90
===================================================================
--- gcc/testsuite/gfortran.dg/null_5.f90	(.../tags/gcc_4_8_2_release)	(wersja 207996)
+++ gcc/testsuite/gfortran.dg/null_5.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -34,7 +34,7 @@
 end subroutine test_PR34547_1
 
 subroutine test_PR34547_2 ()
-  print *, null () ! { dg-error "in data transfer statement requires MOLD" }
+  print *, null () ! { dg-error "Invalid context" }
 end subroutine test_PR34547_2
 
 subroutine test_PR34547_3 ()
Index: gcc/testsuite/gfortran.dg/proc_ptr_43.f90
===================================================================
--- gcc/testsuite/gfortran.dg/proc_ptr_43.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/proc_ptr_43.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,19 @@
+! { dg-do compile }
+!
+! PR 58099: [4.8/4.9 Regression] [F03] over-zealous procedure-pointer error checking
+!
+! Contributed by Daniel Price <daniel.price@monash.edu>
+
+  implicit none
+  procedure(real), pointer :: wfunc
+
+  wfunc => w_cubic 
+ 
+contains
+
+  pure real function w_cubic(q2)
+    real, intent(in) :: q2
+    w_cubic = 0.
+  end function
+
+end
Index: gcc/testsuite/gfortran.dg/typebound_generic_15.f90
===================================================================
--- gcc/testsuite/gfortran.dg/typebound_generic_15.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/typebound_generic_15.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,18 @@
+! { dg-do compile }
+!
+! PR 60231: [4.8/4.9 Regression] ICE on undefined generic
+!
+! Contributed by Antony Lewis <antony@cosmologist.info>
+
+module Objects
+
+  Type TObjectList
+  contains
+    procedure :: Add1             ! { dg-error "must be a module procedure" }
+    procedure :: Add2             ! { dg-error "must be a module procedure" }
+    generic :: Add => Add1, Add2  ! { dg-error "are ambiguous" }
+  end Type
+
+end module
+
+! { dg-final { cleanup-modules "Objects" } }
Index: gcc/testsuite/gfortran.dg/extends_15.f90
===================================================================
--- gcc/testsuite/gfortran.dg/extends_15.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/extends_15.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,16 @@
+! { dg-do compile }
+!
+! PR 58355: [4.7/4.8/4.9 Regression] [F03] ICE with TYPE, EXTENDS before parent TYPE defined
+!
+! Contributed by Andrew Benson <abensonca@gmail.com>
+
+module ct
+  public :: t1
+
+  type, extends(t1) :: t2   ! { dg-error "has not been previously defined" }
+
+  type :: t1
+  end type
+end
+
+! { dg-final { cleanup-modules "ct" } }
Index: gcc/testsuite/gfortran.dg/optional_class_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/optional_class_1.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/optional_class_1.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,45 @@
+! { dg-do run }
+!
+! PR fortran/57445
+!
+! Contributed by Tobias Burnus  <burnus@gcc.gnu.org>
+!
+! Spurious assert was added at revision 192495
+!
+module m
+  implicit none
+  type t
+    integer :: i
+  end type t
+contains
+  subroutine opt(xa, xc, xaa, xca)
+    type(t),  allocatable, intent(out), optional :: xa
+    class(t), allocatable, intent(out), optional :: xc
+    type(t),  allocatable, intent(out), optional :: xaa(:)
+    class(t), allocatable, intent(out), optional :: xca(:)
+    if (present (xca)) call foo_opt(xca=xca)
+  end subroutine opt
+  subroutine foo_opt(xa, xc, xaa, xca)
+    type(t),  allocatable, intent(out), optional :: xa
+    class(t), allocatable, intent(out), optional :: xc
+    type(t),  allocatable, intent(out), optional :: xaa(:)
+    class(t), allocatable, intent(out), optional :: xca(:)
+    if (present (xca)) then
+      if (allocated (xca)) deallocate (xca)
+      allocate (xca(3), source = [t(9),t(99),t(999)])
+    end if
+  end subroutine foo_opt
+end module m
+  use m
+  class(t), allocatable :: xca(:)
+  allocate (xca(1), source = t(42))
+  select type (xca)
+    type is (t)
+      if (any (xca%i .ne. [42])) call abort
+  end select
+  call opt (xca = xca)
+  select type (xca)
+    type is (t)
+      if (any (xca%i .ne. [9,99,999])) call abort
+  end select
+end
Index: gcc/testsuite/gfortran.dg/dynamic_dispatch_12.f90
===================================================================
--- gcc/testsuite/gfortran.dg/dynamic_dispatch_12.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/dynamic_dispatch_12.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,74 @@
+! { dg-do run }
+!
+! PR 59654: [4.8/4.9 Regression] [OOP] Broken function table with complex OO use case
+!
+! Contributed by Thomas Clune <Thomas.L.Clune@nasa.gov>
+
+module TestResult_mod
+  implicit none
+
+  type TestResult
+    integer :: numRun = 0
+  contains
+    procedure :: run
+    procedure, nopass :: getNumRun
+  end type
+
+contains
+
+  subroutine run (this)
+    class (TestResult) :: this
+    this%numRun = this%numRun + 1
+  end subroutine
+
+  subroutine getNumRun()
+   end subroutine
+
+end module
+
+
+module BaseTestRunner_mod
+  implicit none
+
+  type :: BaseTestRunner
+  contains
+    procedure, nopass :: norun
+  end type
+
+contains
+
+  function norun () result(result)
+    use TestResult_mod, only: TestResult
+    type (TestResult) :: result
+  end function
+
+end module
+
+
+module TestRunner_mod
+  use BaseTestRunner_mod, only: BaseTestRunner
+  implicit none
+end module
+
+
+program main
+  use TestRunner_mod, only: BaseTestRunner
+  use TestResult_mod, only: TestResult
+  implicit none
+
+  type (TestResult) :: result
+
+  call runtest (result)
+  
+contains
+
+  subroutine runtest (result)
+    use TestResult_mod, only: TestResult
+    class (TestResult) :: result
+    call result%run()
+    if (result%numRun /= 1) call abort()
+  end subroutine
+
+end
+
+! { dg-final { cleanup-modules "TestResult_mod BaseTestRunner_mod TestRunner_mod" } }
Index: gcc/testsuite/gfortran.dg/proc_ptr_45.f90
===================================================================
--- gcc/testsuite/gfortran.dg/proc_ptr_45.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/proc_ptr_45.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,24 @@
+! { dg-do compile }
+!
+! PR fortran/49397
+!
+! Valid per IR F08/0060 and F2008Corr2, C729
+!
+Program m5
+  Print *,f()
+Contains
+  Subroutine s
+    Procedure(Real),Pointer :: p
+    Print *,g()
+    p => f                           ! (1)
+    Print *,p()
+    p => g                           ! (2)
+    Print *,p()
+  End Subroutine
+End Program
+Function f()
+  f = 1
+End Function
+Function g()
+  g = 2
+End Function
Index: gcc/testsuite/gfortran.dg/unlimited_polymorphic_15.f90
===================================================================
--- gcc/testsuite/gfortran.dg/unlimited_polymorphic_15.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/unlimited_polymorphic_15.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,17 @@
+! { dg-do compile }
+!
+! PR 59493: [OOP] ICE: Segfault on Class(*) pointer association
+!
+! Contributed by Hossein Talebi <talebi.hossein@gmail.com>
+
+  implicit none
+
+  type ty_mytype1
+  end type
+
+  class(ty_mytype1), allocatable, target:: cla1
+  class(*), pointer :: ptr
+
+  ptr => cla1
+
+end
Index: gcc/testsuite/gfortran.dg/fmt_g_1.f90
===================================================================
--- gcc/testsuite/gfortran.dg/fmt_g_1.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/fmt_g_1.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,11 @@
+! { dg-do run }
+! PR59771 Cleanup handling of Gw.0 and Gw.0Ee format
+! Test case prepared by Dominique d'Humieres <dominiq@lps.ens.fr>
+       PROGRAM FOO
+       character(len=60) :: buffer, buffer1
+
+       write (buffer ,'(6(1X,1PG9.0e2))') 0.0, 0.04, 0.06, 0.4, 0.6, 243.0
+       write (buffer1,'(6(1X,1PE9.0e2))') 0.0, 0.04, 0.06, 0.4, 0.6, 243.0
+
+       if (buffer /= buffer1) call abort
+       end
Index: gcc/testsuite/gfortran.dg/elemental_subroutine_9.f90
===================================================================
--- gcc/testsuite/gfortran.dg/elemental_subroutine_9.f90	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gfortran.dg/elemental_subroutine_9.f90	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,39 @@
+! { dg-do run }
+!
+! PR fortran/59906
+!
+! Contributed by H Anlauf  <anlauf@gmx.de>
+!
+! Failed generate character scalar for scalarized loop for elemantal call.
+!
+program x
+  implicit none
+  call y('bbb')
+contains
+
+  subroutine y(str)
+    character(len=*), intent(in) :: str
+    character(len=len_trim(str)) :: str_aux
+    character(len=3) :: str3 = 'abc'
+
+    str_aux = str
+
+    ! Compiled but did not give correct result
+    if (any (str_cmp((/'aaa','bbb'/), str) .neqv. [.FALSE.,.TRUE.])) call abort
+
+    ! Did not compile
+    if (any (str_cmp((/'bbb', 'aaa'/), str_aux) .neqv. [.TRUE.,.FALSE.])) call abort
+
+    ! Verify patch
+    if (any (str_cmp((/'bbb', 'aaa'/), str3) .neqv. [.FALSE.,.FALSE.])) call abort
+    if (any (str_cmp((/'bbb', 'aaa'/), 'aaa') .neqv. [.FALSE.,.TRUE.])) call abort
+
+  end subroutine y
+
+  elemental logical function str_cmp(str1, str2)
+    character(len=*), intent(in) :: str1
+    character(len=*), intent(in) :: str2
+    str_cmp = (str1 == str2)
+  end function str_cmp
+
+end program x
Index: gcc/testsuite/gcc.c-torture/execute/20140212-1.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/20140212-1.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/20140212-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,37 @@
+/* PR rtl-optimization/60116 */
+/* Reported by Zhendong Su <su@cs.ucdavis.edu> */
+
+extern void abort (void);
+
+int a, b, c, d = 1, e, f = 1, h, i, k;
+char g, j;
+
+void
+fn1 (void)
+{
+  int l;
+  e = 0;
+  c = 0;
+  for (;;)
+    {
+      k = a && b;
+      j = k * 54;
+      g = j * 147;
+      l = ~g + (long long) e && 1;
+      if (d)
+	c = l;
+      else
+	h = i = l * 9UL;
+      if (f)
+	return;
+    }
+}
+
+int
+main (void)
+{
+  fn1 ();
+  if (c != 1)
+    abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr58984.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr58984.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr58984.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,57 @@
+/* PR tree-optimization/58984 */
+
+struct S { int f0 : 8; int : 6; int f1 : 5; };
+struct T { char f0; int : 6; int f1 : 5; };
+
+int a, *c = &a, e, n, b, m;
+
+static int
+foo (struct S p)
+{
+  const unsigned short *f[36];
+  for (; e < 2; e++)
+    {
+      const unsigned short **i = &f[0];
+      *c ^= 1;
+      if (p.f1)
+	{
+	  *i = 0;
+	  return b;
+	}
+    }
+  return 0;
+}
+
+static int
+bar (struct T p)
+{
+  const unsigned short *f[36];
+  for (; e < 2; e++)
+    {
+      const unsigned short **i = &f[0];
+      *c ^= 1;
+      if (p.f1)
+	{
+	  *i = 0;
+	  return b;
+	}
+    }
+  return 0;
+}
+
+int
+main ()
+{
+  struct S o = { 1, 1 };
+  foo (o);
+  m = n || o.f0;
+  if (a != 1)
+    __builtin_abort ();
+  e = 0;
+  struct T p = { 1, 1 };
+  bar (p);
+  m |= n || p.f0;
+  if (a != 0)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr60017.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr60017.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr60017.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,33 @@
+/* PR target/60017 */
+
+extern void abort (void);
+
+struct S0
+{
+  short m0;
+  short m1;
+};
+
+struct S1
+{
+  unsigned m0:1;
+  char m1[2][2];
+  struct S0 m2[2];
+};
+
+struct S1 x = { 1, {{2, 3}, {4, 5}}, {{6, 7}, {8, 9}} };
+
+struct S1 func (void)
+{
+  return x;
+}
+
+int main (void)
+{
+  struct S1 ret = func ();
+
+  if (ret.m2[1].m1 != 9)
+    abort ();
+
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/20131127-1.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/20131127-1.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/20131127-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,34 @@
+/* PR middle-end/59138 */
+/* Testcase by John Regehr <regehr@cs.utah.edu> */
+
+extern void abort (void);
+
+#pragma pack(1)
+
+struct S0 {
+  int f0;
+  int f1;
+  int f2;
+  short f3;
+};
+
+short a = 1;
+
+struct S0 b = { 1 }, c, d, e;
+
+struct S0 fn1() { return c; }
+
+void fn2 (void)
+{
+  b = fn1 ();
+  a = 0;
+  d = e;
+}
+
+int main (void)
+{
+  fn2 ();
+  if (a != 0)
+    abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr59358.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr59358.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr59358.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,44 @@
+/* PR tree-optimization/59358 */
+
+__attribute__((noinline, noclone)) int
+foo (int *x, int y)
+{
+  int z = *x;
+  if (y > z && y <= 16)
+    while (y > z)
+      z *= 2;
+  return z;
+}
+
+int
+main ()
+{
+  int i;
+  for (i = 1; i < 17; i++)
+    {
+      int j = foo (&i, 16);
+      int k;
+      if (i >= 8 && i <= 15)
+	k = 16 + (i - 8) * 2;
+      else if (i >= 4 && i <= 7)
+	k = 16 + (i - 4) * 4;
+      else if (i == 3)
+	k = 24;
+      else
+	k = 16;
+      if (j != k)
+	__builtin_abort ();
+      j = foo (&i, 7);
+      if (i >= 7)
+	k = i;
+      else if (i >= 4)
+	k = 8 + (i - 4) * 2;
+      else if (i == 3)
+	k = 12;
+      else
+	k = 8;
+      if (j != k)
+	__builtin_abort ();
+    }
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr59014-2.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr59014-2.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr59014-2.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,23 @@
+/* PR tree-optimization/59014 */
+
+__attribute__((noinline, noclone)) long long int
+foo (long long int x, long long int y)
+{
+  if (((int) x | (int) y) != 0)
+    return 6;
+  return x + y;
+}
+
+int
+main ()
+{
+  if (sizeof (long long) == sizeof (int))
+    return 0;
+  int shift_half = sizeof (int) * __CHAR_BIT__ / 2;
+  long long int x = (3LL << shift_half) << shift_half;
+  long long int y = (5LL << shift_half) << shift_half;
+  long long int z = foo (x, y);
+  if (z != ((8LL << shift_half) << shift_half))
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr59101.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr59101.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr59101.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,15 @@
+/* PR target/59101 */
+
+__attribute__((noinline, noclone)) int
+foo (int a)
+{
+  return (~a & 4102790424LL) > 0 | 6;
+}
+
+int
+main ()
+{
+  if (foo (0) != 7)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr58831.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr58831.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr58831.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,40 @@
+#include <assert.h>
+
+int a, *b, c, d, f, **i, p, q, *r;
+short o, j;
+
+static int __attribute__((noinline, noclone))
+fn1 (int *p1, int **p2)
+{
+  int **e = &b;
+  for (; p; p++)
+    *p1 = 1;
+  *e = *p2 = &d;
+
+  assert (r);
+
+  return c;
+}
+
+static int ** __attribute__((noinline, noclone))
+fn2 (void)
+{
+  for (f = 0; f != 42; f++)
+    {
+      int *g[3] = {0, 0, 0};
+      for (o = 0; o; o--)
+        for (; a > 1;)
+          {
+            int **h[1] = { &g[2] };
+          }
+    }
+  return &r;
+}
+
+int
+main (void)
+{
+  i = fn2 ();
+  fn1 (b, i);
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr58726.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr58726.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr58726.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,26 @@
+/* PR rtl-optimization/58726 */
+
+int a, c;
+union { int f1; int f2 : 1; } b;
+
+short
+foo (short p)
+{
+  return p < 0 ? p : a;
+}
+
+int
+main ()
+{
+  if (sizeof (short) * __CHAR_BIT__ != 16
+      || sizeof (int) * __CHAR_BIT__ != 32)
+    return 0;
+  b.f1 = 56374;
+  unsigned short d;
+  int e = b.f2;
+  d = e == 0 ? b.f1 : 0;
+  c = foo (d);
+  if (c != (short) 56374)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr59014.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr59014.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr59014.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,25 @@
+/* PR tree-optimization/59014 */
+
+int a = 2, b, c, d;
+
+int
+foo ()
+{
+  for (;; c++)
+    if ((b > 0) | (a & 1))
+      ;
+    else
+      {
+	d = a;
+	return 0;
+      }
+}
+
+int
+main ()
+{
+  foo ();
+  if (d != 2)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/execute/pr59388.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr59388.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr59388.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,11 @@
+/* PR tree-optimization/59388 */
+
+int a;
+struct S { unsigned int f:1; } b;
+
+int
+main ()
+{
+  a = (0 < b.f) | b.f;
+  return a;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr58970-1.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr58970-1.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr58970-1.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,11 @@
+/* PR middle-end/58970 */
+
+struct T { int b : 1; };
+struct S { struct T t[1]; };
+
+void
+foo (int x, struct S *s)
+{
+  if (x == -1)
+    s->t[x].b = 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr59803.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr59803.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr59803.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,27 @@
+/* PR target/59803 */
+
+extern void baz (void) __attribute__ ((__noreturn__));
+struct A { int g, h; };
+extern struct A a;
+struct B { unsigned char i, j, k, l, m; };
+int c, d, e;
+static int f;
+
+void
+foo (void)
+{
+  f = 1;
+}
+
+void
+bar (struct B *x)
+{
+  x->i = e;
+  x->k = c;
+  x->l = d;
+  x->j = a.h;
+  x->m = f;
+  if (x->i != e) baz ();
+  if (x->k != c) baz ();
+  if (x->j != a.h) baz ();
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr58997.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr58997.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr58997.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,19 @@
+/* PR rtl-optimization/58997 */
+
+int a, b, c, e;
+short d;
+char h;
+
+void
+foo ()
+{
+  while (b)
+    {
+      d = a ? c : 1 % a;
+      c = d;
+      h = d;
+      if (!h)
+	while (e)
+	  ;
+    }
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr58970-2.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr58970-2.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr58970-2.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,11 @@
+/* PR middle-end/58970 */
+
+struct T { char a : 8; char b : 1; };
+struct S { char x; struct T t[1]; };
+
+void
+foo (int x, struct S *s)
+{
+  if (x == -1)
+    s->t[x].b = 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr59362.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr59362.c	(.../tags/gcc_4_8_2_release)	(wersja 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr59362.c	(.../branches/gcc-4_8-branch)	(wersja 207996)
@@ -0,0 +1,21 @@
+/* PR tree-optimization/59362 */
+
+char *
+foo (char *r, int s)
+{
+  r = __builtin___stpcpy_chk (r, "abc", __builtin_object_size (r, 1));
+  if (s)
+    r = __builtin___stpcpy_chk (r, "d", __builtin_object_size (r, 1));
+  return r;
+}
+
+char *a;
+long int b;
+
+void
+bar (void)
+{
+  b = __builtin_object_size (0, 0);
+  a = __builtin___stpcpy_chk (0, "", b);
+  b = __builtin_object_size (a, 0);
+}
